#ifndef lint
static char SccsId2[] = "@(#)getcode.c	1.3\t8/27/91";
#endif

/* function to return an ercc code from a username 
   returns 0 if unable to get an ercc file entry 
*/

#include <sys/types.h>
#include <ctype.h>
#include <string.h>
#include <strings.h>
#include <malloc.h>
#include <stdio.h>
#include <pwd.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <fcntl.h>

#define CODEFILE  "/var/tmp/lprpf/registrations"

static int numentries;          /* number of entries in ercc code file */
static struct ercc_entry  *base_pt; /* array to hold printer group file */
static char *pp,*tp,*endp;                

static struct ercc_entry{
    char  code[7];
    char  name[30];
    char  uname[9];
};



int
getcode(user,code)
char	*user, *code;
{
int pos;
struct ercc_entry *current;
#ifdef DEBUG
FILE *debug=fopen("/tmp/code_debug","a");
#endif

 if (read_ercc_file() == 0){   /* read ercc file into memory - */
#ifdef DEBUG
    (void)fprintf(debug,"getcode: failed to read ercc code file ");
#endif
    return(0);
 }

for(pos=0; pos < numentries; pos++){         /* scan it for user name - return 0 if cannot find it */
      current = &base_pt[pos];
      if(strcmp(user,current->uname) == 0) {
            (void)strncpy(code,current->code,6);
	    code[6] = NULL;                 /* ooops ! */
	    return(1);
	}
   }
#ifdef DEBUG
   (void)fprintf(debug, "getcode: can't find %s in ercc reg\n",user);
#endif
   return(0);
}


static
int read_ercc_file()
{

int fp;                    /* file descriptor for ercc code file */
struct stat statbuff;      /* status of ercc code file */
struct ercc_entry *current;/* the ercc entry currently processed */
char *addr;                /* pointer to initial read of file */
int pos;                   /* loop counter */
char *cp;



if((fp=open(CODEFILE,O_RDONLY)) <0){
    perror("getcode: failed to open ercc code file.");
    return(0);
    }

if(fstat(fp,&statbuff) != 0){
    perror("getcode: failed to stat ercc code file.");
    return(0);
    }

if((addr = malloc((unsigned)statbuff.st_size+1)) == NULL){
    (void)fprintf(stderr, "getcode: malloc failed\n");
    return(0);
    } 

if(read(fp,addr, (int)statbuff.st_size) != statbuff.st_size){
    perror("getcode: read failed on group file");
    return(0);
    }

/* the ercc code file is now in memory */

endp = addr + statbuff.st_size;
if (close(fp) == -1){
    perror("Error closing ercc code file.");
    return(0);
    }

tp = addr;

/* count number of entries */
numentries = 0;
while(tp < endp){
     if(*tp++ == '\n') numentries++;
     }


if ((base_pt = (struct ercc_entry *)malloc((unsigned)sizeof(struct ercc_entry) *numentries)) ==NULL){
   (void)fprintf(stderr, "getcode: malloc failed.\n");
   return(0);
}

tp = addr;  /* point tp at first line of erccreg file in memory */
for(pos=0; pos < numentries; pos++){
      current = &base_pt[pos];
      blank_newline();
      cp = strtok(pp,"\t");
      (void)strcpy(current->code,cp);
      cp = strtok((char *)NULL,"\t");
      (void)strcpy(current->name,cp);
      cp = strtok((char *)NULL,"\n");	
	/* We rely here on the fact that there won't be a newline in the
	 * string we're working on (it was 'nulled out' by blank_newline()).
	 * All we want is strtok() to give us a pointer to the rest of the
	 * current string - this seems to be the easiest way to do it.
	 */
      (void)strcpy(current->uname,cp);      
     }
free(addr);

return(1);
}

static
blank_newline()
{
/* Preconditions:
 *	tp points to start of line to be processed this time round the loop
 *	pp undefined
 *
 * Postconditions:
 *	pp points to start of string to be processed this time round the loop
 *		(newline has been replaced by '\0'
 *	tp points to start of next line
 */
 pp=tp;		/* make pp point to start of this line */
 while(*tp != '\n') tp++;
 *(tp++)='\0';  /* overwrite newline with null character and move tp */
		/* to point to start of next line */
}

static
char *
strtok(s, sep)
	register char *s, *sep;
{
	register char *p;
	register c;
	static char *lasts;

	if (s == 0)
		s = lasts;
	if (s == 0)
		return (0);

	while (c = *s) {
		if (!index(sep, c))
			break;
		s++;
	}

	if (c == '\0') {
		lasts = 0;
		return (0);
	}

	for (p = s; c = *++p; )
		if (index(sep, c))
			break;

	if (c == '\0')
		lasts = 0;
	else {
		*p++ = '\0';
		lasts = p;
	}
	return (s);
}
