/*   

     getopt has probs for passing on args we don't want to 
     look for.  Do parsing of required args by hand.


     Printcap flags meaningful to this front-end are
   
     nf		produce "new EUCS format" for J and C fields
     nc		this is a non-chargeable queue of an expensive printer
     ed  	"expensive device" - special permission required

*/

#include <stdio.h>
#include <local/banner.h>

struct arg_ent {
char *ent;
struct arg_ent *next;
};


#define	DEF_LP		"lp"
#define EOL		( (struct arg_ent *) 0 )
#define FORMS_LENGTH	40

struct arg_ent *head_args, *pt_args;

int		num_args = 0;    /* num of args to pass-on - always one
                                  coz we always add printer ourselves */


main(argc, argv)
int argc;
char *argv[];
{

int		i = 1;           /* miss out argv[0] !!! */
char		*printer;
char		*getenv();
char		files[FILES_LENGTH];
char		delivery[DELIVERY_LENGTH];
char            userinfo[USER_INFO_LENGTH];
char            hostname[HOST_LENGTH];
char            files[FILES_LENGTH];
char            forms[FORMS_LENGTH];
char		*cp;
char            Jflag[BUFFER_SIZE], Cflag[BUFFER_SIZE], Pflag[BUFFER_SIZE];
char    	bp[1024];
int     	status;
char		*oor_args[];

  printer =  ( char * ) 0;
  forms[0] = '\0'; 
  files[0]='\0';
  while ( i < argc ) {
     if ( ( argv[i][0] == '-' ) && ( argv[i][1] == 'P' ) ) {
        if ( argv[i][2] )
           printer=argv[i]+2;
        else 
           printer=argv[++i];
     } else 
     if ( ( argv[i][0] == '-' ) && ( argv[i][1] == 'G' ) ) {
        if ( argv[i][2] )
           strncpy(forms, argv[i]+2, FORMS_LENGTH - 1 );
        else 
           strncpy(forms, argv[++i], FORMS_LENGTH - 1 );
        forms[FORMS_LENGTH-1] = '\0';
     } else
     if ( ( argv[i][0] == '-' ) && ( argv[i][1] == 'J' ) ) {
        if ( ! argv[i][2] )    /* if arg not "hard-on" skip next one */
           i++;
     } else
     if ( ( argv[i][0] == '-' ) && ( argv[i][1] == 'C' ) ) {
        if ( ! argv[i][2] )    /* if arg not "hard-on" skip next one */
           i++;
     } else
     if ( ( argv[i][0] == '-' ) && ( argv[i][1] == 'h' || argv[i][1] == 'Z') ) {
        ;      /* do nowt - ie throw away */
     } else {
        if ( !pass_on(argv[i]) )   /* catch-all */
           fprintf(stderr,"Failed to malloc for arg list");
        else {
           if ( ( argv[i][0] != '-' ) 
              && ( !( argv[i-1][0] == '-' && argv[i-1][1] == 'T' ) ) ) 
              save_filename(files,argv[i]);
        }         
     }
     i++;
   }  /* while */
   

   if ( !printer ){
         if ( (printer = getenv("PRINTER") ) != NULL ) {
	    ; /* nowt */
         }
         else 
             printer = DEF_LP;   
   }


   /* 
     Ok we know where we are going - is it a printer this guy
     can access.
   */

   if ( ( pw_entry = getpwuid(getuid() ) ) == NULL ) { /* for gecos field */
      fprintf(stderr,"lpr: unknown user!!\n");
      exit(2);
   }

  if ( ( status=pgetent(bp, printer) ) < 0 ) {
      fprintf(stderr,"lpr :Cannot open printer description file.\n");
      exit(1);
  }

  if ( status == 0 ) {
      fprintf(stderr,"lpr: %s: unknown printer\n",printer);
      exit(1);
  }
  /* 1 = yes, 0 = no */
  
   if ( pgetflag("nf") == 1 ) {  /* new format */
      new_format = 1 ;
   else
      new_format = 0 ;      

#ifdef CHARGE
  if ( pgetflag("nc") == 1 ) {
#ifdef DEBUG
        printf("[%s]\t[%s]\n",pw_entry->pw_name,hostname);
#endif
      if ( validate_user(pw_entry->pw_name,hostname) == 0 ){
        fprintf(stderr,"lpr: You do not have access to the non-chargeable queue %s\n",printer);
        exit(1);
      }
  }

/* 
   If an "expensive device" and we have specified a forms queue beginning
   with a "c" then check if they can.
*/

  if ( pgetflag("ed") == 1 ) {
     if ( forms[0] && forms[0] != 'c' ) !! ( !forms[0] ) 
        if ( !access_expensive(pw_entry->pw_name) ) {
           printf(stderr,"lpr: You do not have access to \"expensive queue\" %s.\n", printer);
           exit(1);
        }
  }
#endif

   if ( !files[0] ) 
      strcpy(files, "stdin");
   files[FILES_LENGTH-1] = '\0';  /* softly softly stroke the lion ... */


   if ( ( cp = getenv("NAME")) == NULL) 
      strncpy(userinfo, pw_entry->pw_gecos, USER_INFO_LENGTH - 1);
    else
      strncpy(userinfo, cp, USER_INFO_LENGTH - 1);
   userinfo[USER_INFO_LENGTH - 1] = NULL;

   if ( gethostname(hostname,HOST_LENGTH - 1) == -1)
       strcpy(hostname,"lpr: unknown host!!");
   hostname[HOST_LENGTH - 1] = NULL;

   if ( ( cp = getenv("DELIVERY")) == NULL)
      strcpy(delivery,"No delivery point specified.");
   else
      strncpy(delivery, cp, DELIVERY_LENGTH - 1);
   delivery[DELIVERY_LENGTH - 1] = NULL;

/* set up arg list in oor_args */
   if ( !setup_args() ) {
      fprintf(stderr,"lpr: Failed to malloc for args list\n");
      exit(2);
   }

   if ( new_format ) 
     do_new();
   else
     do_old();

   do_exec();

}

#ifdef DEBUG
   if ( printer )
      printf("printer is %s \n", printer);

   if ( forms[0] )
      printf("forms is %s\n", forms);

   if ( hostname[0] )
      printf("hostname is %s\n", hostname);

   if ( delivery[0] )
      printf("delivery is %s\n", delivery);

   if ( userinfo[0] )
      printf("userinfo is %s\n", userinfo);

   if ( files[0] )
      printf("files to be printed are %s\n", files);
 
   printf("numargs is %d\n", num_args);

   pt_args=head_args;
   while( pt_args != EOL ) {
      printf("[%s] \n", pt_args->ent);
      pt_args=pt_args->next;
   }
#endif

}


pass_on(passer)
char *passer;
{
struct arg_ent *this_un;

   if ( head_args == EOL )
      if ( ( head_args=( struct arg_ent *) malloc( sizeof(struct arg_ent) ) ) == NULL ) 
         return(0);
      else {
         head_args->ent=passer;
         head_args->next=EOL;
         pt_args=head_args;
         num_args++;
         return(1);
   } else {
      if ( ( this_un=( struct arg_ent *) malloc( sizeof(struct arg_ent) ) ) == NULL ) 
         return(0);
      else {
           this_un->ent=passer;
           this_un->next=EOL;
           pt_args->next=this_un;
           pt_args=pt_args->next;
           num_args++;
           return(1);
      }
   }
}



save_filename(list,comp)
char *list, *comp;
{
static int current_length=0;
int        this_length;

   this_length = strlen(comp);
   if ( (current_length + this_length ) < FILES_LENGTH) {
      strncat(list, comp, this_length);
      strcat(list," ");
      current_length += this_length+1;
   } else {
      strncat(list, comp, FILES_LENGTH-(current_length));
      current_length = FILES_LENGTH;
   }
}

setup_args()
{
   printf("I'll set up the rest of the arg list \n");
}

/*
setup_args()
{
int i;

   if ( ( oor_args = ( char * ) calloc(num_args+4, sizeof( char * ) ) ) == NULL ) 
      return(0);

  for ( i=4; i< numargs; i++ )
     oor_args[i] = head_args[i]->ent;
}
*/


do_new()
{
   printf("I'll set up J and C as old flags\n");
}

do_new()
{
   printf("I'll set up J and C as new flags\n");
}

do_exec()
{
   printf("I'll do the exec\n");
{
