/*==========================================================================
 =                                                                         =
 =                        Project CTI-Print                                =
 =                                                                         =
 = Author:                                                                 =
 =   Panos Dimakopoulos, Systems Programmer,                               =
 =   Computer Technology Institute,                                        =
 =   Division of Computing Facilities,                                     =
 =   P.O. Box 1122,                                                        =
 =   261 10  Patras,                                                       =
 =   Greece                                                                =
 =   (e-mail: dimakop@cti.gr)                                              =
 =   Tel: +30 61 992061                                                    =
 =   Fax: +30 61 993973                                                    =
 =                                                                         =
 = Created by Patrick Powell  <papowell@sdsu.edu>                          =
 =   for LPRng software Sat Aug 26 06:54:25 PDT 1995                       =
 ==========================================================================*/


/*==========================================================================
  Version CTI-LPRng-1.0
  =========================================================================*/


/*
 * $Id: monitorport.c,v 1.1 1995/09/02 15:12:44 papowell Exp $
 */

#include "portable.h"
#include "common.h"
#include "hp4.h"


/*
 * This is the process to monitor for ever the port attached to the printer.
 * When it reads something it sends it through the pipe to its father.
 */
void monitorport()
{
	char buf[MAXLINE+1];
	int rdcnt;


	buf[sizeof(buf)-1] = 0;

	for( ; ; ) {
		buf[0] = 0;
		log(3,"monitorport: starting read");
		rdcnt=port_readline(STDOUT, buf, sizeof(buf)-1, 10);
		if (rdcnt == -1){
			logerr(3,"Cannot read from port %d", STDOUT);
			continue;
		}
		if (rdcnt == 0)	continue;
		log(3,"monitorport: read '%s'",buf);
		if( writecn(pipefd[1],buf,strlen(buf))<0 ){
			logerr(3,"...but cannot write it on pipe");
			fexit(FILTRETRY);
		}
	}/* for loop */
}
