/*==========================================================================
 =                                                                         =
 =                        Project CTI-Print                                =
 =                                                                         =
 = Author:                                                                 =
 =   Panos Dimakopoulos, Systems Programmer,                               =
 =   Computer Technology Institute,                                        =
 =   Division of Computing Facilities,                                     =
 =   P.O. Box 1122,                                                        =
 =   261 10  Patras,                                                       =
 =   Greece                                                                =
 =   (e-mail: dimakop@cti.gr)                                              =
 =   Tel: +30 61 992061                                                    =
 =   Fax: +30 61 993973                                                    =
 =                                                                         =
 = Created by Patrick Powell  <papowell@sdsu.edu>                          =
 =   for LPRng software Sat Aug 26 06:54:25 PDT 1995                       =
 ==========================================================================*/


/*==========================================================================
  Version CTI-LPRng-1.0
  =========================================================================*/


/*
 * $Id: open_trace.c,v 1.1 1995/09/02 15:12:45 papowell Exp $
 */

#include "portable.h"
#include "common.h"
#include "hp4.h"


int open_trace()
{
	char ss[MAXPATHLEN];
	int fd = 0;

	if( trace > 0 ){
		plp_snprintf(ss,sizeof(ss),"/tmp/hp4.%04d", getpid());
		fd = open(ss, O_WRONLY|O_CREAT,0600);
		if (fd < 0) {
			log(2,"Cannot open trace file '%s'", ss);
			fd = 0;
		}
	}
	return( fd );
}
