/*==========================================================================
 =                                                                         =
 =                        Project CTI-Print                                =
 =                                                                         =
 = Author:                                                                 =
 =   Panos Dimakopoulos, Systems Programmer,                               =
 =   Computer Technology Institute,                                        =
 =   Division of Computing Facilities,                                     =
 =   P.O. Box 1122,                                                        =
 =   261 10  Patras,                                                       =
 =   Greece                                                                =
 =   (e-mail: dimakop@cti.gr)                                              =
 =   Tel: +30 61 992061                                                    =
 =   Fax: +30 61 993973                                                    =
 =                                                                         =
 = Created by Patrick Powell  <papowell@sdsu.edu>                          =
 =   for LPRng software Sat Aug 26 06:54:25 PDT 1995                       =
 ==========================================================================*/


/*==========================================================================
  Version CTI-LPRng-1.0
  =========================================================================*/


/*
 * $Id: pr_duplex.c,v 1.2 1995/09/04 14:58:04 papowell Exp $
 */

#include "portable.h"
#include "common.h"
#include "hp4.h"


#define PSDUPLEX "statusdict begin true setduplexmode end\r\n"
#define PCLDUPLEX "\033&l1S"

void pr_duplex()
{
	char *s = 0;
	int len;

	if (zopts && strstr(zopts, "duplex") ){
		if( mode==POSTSCRIPT ){
			s = PSDUPLEX ;
		} else {
			s = PCLDUPLEX ;
		}
		if( s && (len = strlen(s)) ){
			log(4, "pr_duplex: sending '%s'", s );
			write_check(STDOUT,s,"Cannot send duplex string",0);
		}
	}
}
