/*==========================================================================
 =                                                                         =
 =                        Project CTI-Print                                =
 =                                                                         =
 = Author:                                                                 =
 =   Panos Dimakopoulos, Systems Programmer,                               =
 =   Computer Technology Institute,                                        =
 =   Division of Computing Facilities,                                     =
 =   P.O. Box 1122,                                                        =
 =   261 10  Patras,                                                       =
 =   Greece                                                                =
 =   (e-mail: dimakop@cti.gr)                                              =
 =   Tel: +30 61 992061                                                    =
 =   Fax: +30 61 993973                                                    =
 =                                                                         =
 = Created by Patrick Powell  <papowell@sdsu.edu>                          =
 =   for LPRng software Sat Aug 26 06:54:25 PDT 1995                       =
 ==========================================================================*/


/*==========================================================================
  Version CTI-LPRng-1.0
  =========================================================================*/


/*
 * $Id: wait_printer.c,v 1.1 1995/09/02 15:12:53 papowell Exp $
 */

#include "portable.h"
#include "common.h"
#include "hp4.h"

/*
 * We wait for the printer (fd 1)
 */

void wait_printer(i)
int i;
{
	fd_set  writefds;
	struct timeval timeout;

    FD_ZERO(&writefds);
    FD_SET(1,&writefds);
	timeout.tv_sec = wait_time;
	timeout.tv_usec = 0;

	if ( retries >= 0 )	{
		if( wait_time > 0 ){
			log(2,"Let's sleep for %d secs", wait_time);
			select( 2, (fd_set *)0, &writefds, (fd_set *)0, &timeout ); 
		}
		if( retries > 0 ) --retries;
	} else {
		log(2,"Can not sleep anymore");
		cleanup(SIGTERM);
		fexit(i);
	}
}
