
/*
**  supplement to translate pc8 encoded Files to latin 1
*/

#if ! defined ( PC8LAT )
#define PC8LAT 0
#endif
#undef PC8LATDONE

#if ! defined (PC8LATDONE ) && ( PC8LAT == 0 )
#if ! defined Z_XLATE
char *z_options_xlation = NULL;
#define Z_XLATE
#endif
#define PC8LATDONE
#undef  PC8LAT
#define PC8LAT 1 
#endif 

#if ! defined (PC8LATDONE ) && ( PC8LAT == 1 )
#ifdef FORLPD
if (strstr (z_options, "pc8")) {
  z_options_xlation = (char *) malloc (strlen (optarg) *sizeof (char));
  if (z_options_xlation == NULL) {
    fprintf (stderr, "psflpd: No memory available for z_options_orientation!\n");
    exit (DISCARD_JOB);
  } else {
    (void) sprintf (z_options_xlation, "%s", optarg);
    need_xlate = 1;
    {
      int i;
      
      /*	translation table PC8 -> ECMA94 Latin 1
		
		This translation table was built according to character
		encoding talbes on pages A-3 and A-4 of
		Benutzerhandbuch fuer den Drucker LaserJet III
		Bestell-Nr 33449-90909
		HP Deutschland
		*/
      
      xlate [ 128 ] = 199 ; /* gross C mit Cedille	*/
      xlate [ 129 ] = 252 ; /* klein u mit Umlaut	*/
      xlate [ 130 ] = 233 ; /* klein e mit Akut	*/
      xlate [ 131 ] = 226 ; /* klein a mit Zirkumflex	*/
      xlate [ 132 ] = 228 ; /* klein a mit Umlaut	*/
      xlate [ 133 ] = 224 ; /* klein a mit Gravis	*/
      xlate [ 134 ] = 229 ; /* klein a mit Ring	*/
      xlate [ 135 ] = 231 ; /* klein c mit Cedille	*/
      xlate [ 136 ] = 234 ; /* klein e mit Zirkumflex	*/
      xlate [ 137 ] = 235 ; /* klein e mit Umlaut	*/
      xlate [ 138 ] = 232 ; /* klein e mit Gravis	*/
      xlate [ 139 ] = 239 ; /* klein i mit Umlaut	*/
      xlate [ 140 ] = 238 ; /* klein i mit Zirkumflex	*/
      xlate [ 141 ] = 236 ; /* klein i mit Gravis	*/
      xlate [ 142 ] = 196 ; /* gross A mit Umlaut	*/
      xlate [ 143 ] = 197 ; /* gross A mit Ring	*/
      xlate [ 144 ] = 201 ; /* gross E mit Akut	*/
      xlate [ 145 ] = 230 ; /* klein Ligatur a e	*/
      xlate [ 146 ] = 198 ; /* gross Ligatur a e	*/
      xlate [ 147 ] = 244 ; /* klein o mit Zirkumflex	*/
      xlate [ 148 ] = 246 ; /* klein o mit Umlaut	*/
      xlate [ 149 ] = 242 ; /* klein o mit Gravis	*/
      xlate [ 150 ] = 251 ; /* klein u mit Zirkumflex	*/
      xlate [ 151 ] = 249 ; /* klein u mit Gravis	*/
      xlate [ 152 ] = 255 ; /* klein y mit Umlaut	*/
      xlate [ 153 ] = 214 ; /* gross O mit Umlaut	*/
      xlate [ 154 ] = 220 ; /* gross U mit Umlaut	*/
      xlate [ 155 ] = 162 ; /* W"ahrungszeichen Cent	*/
      xlate [ 156 ] = 163 ; /* W"ahrungszeichen Pfund	*/
      xlate [ 157 ] = 165 ; /* W"ahrungszeichen Yen	*/
      xlate [ 158 ] = 215 ; /* - nicht darstellbar -	*/
      xlate [ 159 ] = 215 ; /* - nicht darstellbar -	*/
      xlate [ 160 ] = 225 ; /* klein a mit Akut	*/
      xlate [ 161 ] = 237 ; /* klein i mit Akut	*/
      xlate [ 162 ] = 243 ; /* klein o mit Akut	*/
      xlate [ 163 ] = 250 ; /* klein u mit Akut	*/
      xlate [ 164 ] = 241 ; /* klein n mit Tilde	*/
      xlate [ 165 ] = 209 ; /* gross n mit Tilde	*/
      xlate [ 166 ] = 170 ; /* hochgestelltes klein a	*/
      xlate [ 167 ] = 186 ; /* hochgestelltes klein o	*/
      xlate [ 168 ] = 191 ; /* umgekehrtes Fragezeichen	*/
      xlate [ 169 ] = 215 ; /* - nicht darstellbar -	*/
      xlate [ 170 ] = 172 ; /* logisches not		*/
      xlate [ 171 ] = 189 ; /* einhalb		        */
      xlate [ 172 ] = 188 ; /* einviertel		*/
      xlate [ 173 ] = 161 ; /* umgekehrtes Ausrufezeichen	*/
      xlate [ 174 ] = 171 ; /* oeffnende Guillemets	*/
      xlate [ 175 ] = 187 ; /* schliessende Guillemets	*/
      xlate [ 176 ] = 215 ; /* - nicht darstellbar -	*/
      xlate [ 177 ] = 127 ; /* 			*/
      
      for ( i = 178 ; i < 229 ; i++ ) 
	{ xlate [i] = 215 ; /* - nicht darstellbar -	*/ }
      xlate [ 225 ] = 223 ; /* scharfes s (klein) */
      xlate [ 230 ] = 181 ; /* griechisches mu	*/
      xlate [ 231 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 232 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 233 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 234 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 235 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 236 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 237 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 238 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 239 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 240 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 241 ] = 177 ; /*  plusminus		*/
      xlate [ 242 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 243 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 244 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 245 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 246 ] = 247 ; /* ./.			*/
      xlate [ 247 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 248 ] = 176 ; /* degree			*/
      xlate [ 249 ] = 183 ; /* hochgestellter Punkt	*/
      xlate [ 250 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 251 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 252 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 253 ] = 178 ; /* hochgestellte 2	*/
      xlate [ 254 ] = 215 ; /*  - nicht darstellbar -	*/
      xlate [ 255 ] = 215 ; /*  - nicht darstellbar -	*/
    }
  }
#ifdef FORLPD
  goto while_end; 
#endif
}
#endif
#undef  PC8LAT
#define PC8LAT 2
#define PC8LATDONE
#endif

#if ! defined (PC8LATDONE ) && ( PC8LAT == 2 )
      if ( z_options_xlation || need_xlate )
#undef  PC8LAT
#define PC8LAT 3
#define PC8LATDONE
#endif
