proc double-left { y } {
# This procedure specifies the actions for the Binding <Double-1>
 global w lpqheader mode butcol listboxheight globalprname
 # switch mode variable
 set mode jobmode
 # change widget-configuration and header-line for job-mode 
 bind $w.main.lpcstatlistbox <Double-1> {} 
 .menuframe.job configure -state normal
 .menuframe.pr  configure -state disabled
 .buttonframe.selectpr configure -state disabled
 pack $w.main.title1 -fill x -before $w.main.header
 $w.main.header configure -textvariable lpqheader1
 $w.main2.header configure -textvariable lpqheader1
 #delete selection (if more than one queue was selected)
 $w.main.lpcstatlistbox selection clear 0 end
 #choose line at mouse position
 set index [$w.main.lpcstatlistbox nearest $y]
 #reduce height, because of titleline
 $w.main.lpcstatlistbox configure -height \
   [expr $listboxheight-1]
 $w.main.lpcstatlistbox activate $index
 $w.main.lpcstatlistbox selection set $index
 #call lpc-lpq with selected line 
 set globalprname [getprselection]
 lpc-lpq $globalprname 
 .buttonframe.selectall configure -relief raised -bg $butcol -text SelectAll
 pack forget .buttonframe.remote
}
  
proc double-right { } {
# This procedure specifies the actions for the Binding <Double-3>
 global globalprname lpcheader w selectedprs mode butcol listboxheight
 #switch mode variable
 set mode prmode
 set globalprname {}
 # change widgets, bindings and header-line for printer mode
 .menuframe.pr configure -state normal
 #.menuframe.queue configure -state normal
 .menuframe.job configure -state disabled
 $w.main.header configure -textvariable lpcheader
 pack forget $w.main.title1
 catch [pack forget $w.main2]
 # reconfigure to old height
 $w.main.lpcstatlistbox configure -height $listboxheight
 bind $w.main.lpcstatlistbox <Double-1> {double-left %y}
 # call lpc-stat
 lpc-stat $selectedprs
 .buttonframe.selectpr configure -state normal
 pack .buttonframe.remote -after .buttonframe.selectall -side left
 .buttonframe.selectall configure -relief raised  -bg $butcol -text SelectAll
 .buttonframe.remote configure -relief raised -bg $butcol
 set remote 0
}


proc lpc-stat { prnames} {
# This procedure executes the lpc lstatus function and writes its results
# into the listbox and the text widget
global w
 #execute lpc stat with -t option. This suppresses paged output
 catch {eval exec lpc -t lstat $prnames } result
 unset prnames
 # break up result in single lines  
 set list [split $result \n]
 set n [llength $list]
 set prsum 0
 # examine type of line
 for {set i 1} {$i < $n} {incr i} {
  set temp [lindex $list $i]
  # for lines with status informations
  if {[string first " " $temp] !=0} {
  set length [string first " " $temp]
  set prname [string range $temp 0 [expr $length-1]]
  set prnames [lappend prnames $prname]
  set prlist($prname) $temp
  incr prsum 
  # for lines with additional information
  } else {
   lappend statinf($prname) $temp
  }
 }
 # refresh listbox with status information
 $w.main.lpcstatlistbox delete 0 end
 set statsortlist [array names prlist]
 set statsortlist [lsort $statsortlist]
 foreach index $statsortlist {
  $w.main.lpcstatlistbox insert end $prlist($index)
 }
 # refresh text widget with additional information
 $w.info.lpcinftextbox configure -state normal
 $w.info.lpcinftextbox delete 1.0 end
 
 set infsortlist [array names statinf]
 set infsortlist [lsort $infsortlist]
 foreach index $infsortlist {
  set n [llength $statinf($index)]
  $w.info.lpcinftextbox insert end "Printer: $index \n"
  for {set i 0}  {$i < $n} {incr i} {  
   $w.info.lpcinftextbox insert end "[lindex $statinf($index) $i] \n"
  }
 }
 $w.info.lpcinftextbox configure -state disabled 
 return $prsum
}

proc lpc-lpq {prname } {
# this procedure implements the lpq option 
 global w lpqheader2
 # set prname in correct style for lpq	
 set iprname -P$prname
 # exec lpq 
 if [catch {exec lpc lpq $iprname } result] {
 } else {
 }
 # split result in single lines
 set list [split $result \n]
 set n [llength $list]
 set jobnumbers1 {}
 set jobnumbers2 {}
 # examine lines
 set prname {}
 set lpqinf {}
 # defines type of lpq-output
 set type 0
 set title1 0
 set title2 0
 for {set i 0} {$i < $n} {incr i} {
  set temp [lindex $list $i]
  split $temp " "
  # examine type of line
  set test [lindex $temp 3]
  # test for third word in line
  switch -regexp -- $test {   
   ^[0-9]+$ {
     if [string match Ready [lindex $temp 0]] {
       lappend lpqinf $temp
     } else {
         set jobnr $test
         if {$title2 == 0} { 
          # local printer
          set jobnumbers1 [lappend jobnumbers1 $jobnr]
          set prjoblist1($jobnr) $temp
         } else {
          # remote printer
          set jobnumbers2 [lappend jobnumbers2 $jobnr]
          set prjoblist2($jobnr) $temp
         }
     }
    }

   ^---+$ {
     # test for AIX printer
     $w.main2.header configure -textvariable lpqheader2
     # go forward one line
     incr i
     set temp [lindex $list $i]
     # scan third word
     set test [lindex $temp 3]
     if {[string match RUNNING [lindex $temp 2]]} {
       # seperate printername and job
       set title2 "Remote Printer: [lrange $temp 0 0]"
       set type 1
       set jobnr [lindex $temp 1]
       set jobnumbers2 [lappend jobnumbers2 $jobnr]
       set prjoblist2($jobnr) $temp  
     } else {
       # this is the titleline if there's no running job
       set title2 "Remote Printer: [lindex $list $i]"
       set type 1
     }
    }
   ^on$     -
   attached {
          # this is the titleline
          if {$title1== 0} {
            set title1 [lrange $temp 0 end]
          } else {
            set title2 [lrange $temp 0 end]
          }
        }
   Job { }  
   default {
     # additional information in PLP Output
     if {$type==0} {
       lappend lpqinf $temp
     } else {
       # in AIX format the jobnumber is the second word in the line 
       if [ regexp {^[0-9]} [lindex $temp 1]] {
          set jobnr [lindex $temp 1]          
          set jobnumbers2 [lappend jobnumbers2 $jobnr]
	  set prjoblist2($jobnr) $temp
        } else {
        # additional information in AIX format
          lappend lpqinf $temp
        }
     }       
   }
  }
}

 # refresh listbox with status information
 $w.main.title1 configure -text $title1 
 $w.main.lpcstatlistbox delete 0 end
 foreach element $jobnumbers1 {
  $w.main.lpcstatlistbox insert end $prjoblist1($element)
 }
 # if there's a remote queue present, bring up second listbox
 if {$title2 != 0} {
   $w.main.lpcstatlistbox configure -height 4
   pack $w.main2 -before $w.messages -side top -fill both -expand true
   pack $w.main2.title2 -fill x
   pack $w.main2.header -fill x
   pack $w.main2.lpcstatlistbox -side left -fill both -expand true
   $w.main2.lpcstatlistbox configure -height 6
   pack $w.main2.scroll -side right -fill y
   $w.main2.title2 configure -text $title2
   $w.main2.lpcstatlistbox delete 0 end
   # fill second listbox with jobs
   foreach element $jobnumbers2 {
    $w.main2.lpcstatlistbox insert end $prjoblist2($element)
   }
 }

 # refresh text widget with additional information
 $w.info.lpcinftextbox configure -state normal
 $w.info.lpcinftextbox delete 1.0 end
 foreach element $lpqinf {
  $w.info.lpcinftextbox insert end "$element \n"
 }
 $w.info.lpcinftextbox configure -state disabled        
}



